package aexp.one_way;

import android.app.Service;
import android.os.IBinder;
import android.util.Log;
import android.os.Bundle;
import android.os.Handler;
import android.content.Intent;
import android.widget.RemoteViews;
import android.widget.ProgressBar;
import java.util.Set;
import java.util.Iterator;

public class CounterService extends Service {
	private static final String LOG_TAG = "COUNTERSERVICE";
    public static final String CATEGORY_IF_COUNTER = 
                        "android.intent.category.aexp.one_way.if.counter";
    public static final String CATEGORY_IF_INCREASECOUNTER = 
                        "android.intent.category.aexp.one_way.if.increasecounter";
    public static final String KEY_IF = "IF";
    private int counter = 0;

    @Override
    public IBinder onBind( Intent intent ) {
        Log.d( LOG_TAG, "onBind: "+intent );
        Set<String> categorySet = intent.getCategories();
        for( Iterator<String> it = categorySet.iterator() ; it.hasNext() ; ) {
            String nextCategory = it.next();
            Log.d( LOG_TAG, "category: "+nextCategory );
            if( CATEGORY_IF_COUNTER.equals( nextCategory ) )
                return counterBinder;
            else
            if( CATEGORY_IF_INCREASECOUNTER.equals( nextCategory ) )
                return increaseCounterBinder;
        }
        return null;
    }

    @Override
    public void onCreate() {
      super.onCreate();
	  Log.d( LOG_TAG,"onCreate" );
    }

    @Override
    public void onDestroy() {
	  super.onDestroy();
	  Log.d( LOG_TAG,"onDestroy" );
    }

// IDL definitions
    private final Counter.Stub counterBinder = 
			new Counter.Stub() {
      public int getCounter() {
        Log.d( LOG_TAG, "getCounter: "+counter );
        return counter;
      }
    };

    private final IncreaseCounter.Stub increaseCounterBinder = 
			new IncreaseCounter.Stub() {
      public void increaseCounter( int diff ) {
        counter += diff;
        Log.d( LOG_TAG, "increaseCounter: "+counter );
      }
    };

}